<?php namespace prlbr\audio;

/* Copyright 2023 Martin Janecke <martin@aneamal.org>
 *
 * Copying and distribution of this file, with or without modification, are
 * permitted in any medium without royalty provided the copyright notice and
 * this notice are preserved. This file is offered as-is, without any warranty.
 */

/* Audio 1.0
 *
 * This simple x-module for Aneamal returns the HTML code to embed a linked
 * audio file in the webpage using HTML's native <audio> element.
 */

const specialchars =
[
	'&' => '&amp;',
	'"' => '&#34;',
	'$' => '&#36;',
	"'" => '&#39;',
	'<' => '&#60;',
	'>' => '&#62;',
];

return function (array $_): string
{
	$href = strtr ($_['hrefs'][0], specialchars);
	$text = strtr ($_['clue'] ?? basename ($_['links'][0]), specialchars);
	$link = $text === ''? '': "<a href='$href'>$text</a>";
	return "<audio src='$href' controls>$link</audio>";
};